# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `specfun` Chapter.
"""

# NAG Copyright 2017-2024.

from ..base import utils

opt_heston_more_greeks = utils._EngineState._get_symbol('s30ndf')
opt_heston_more_greeks.restype = None
opt_heston_more_greeks.argtypes = (
    utils._BYREF_STRING, # Input, calput(len=1).
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[m].
    utils._BYREF_FLOAT64, # Input, s.
    utils._EngineFloat64ArrayType.c_type, # Input, t[n].
    utils._BYREF_FLOAT64, # Input, sigmav.
    utils._BYREF_FLOAT64, # Input, kappa.
    utils._BYREF_FLOAT64, # Input, corr.
    utils._BYREF_FLOAT64, # Input, var0.
    utils._BYREF_FLOAT64, # Input, eta.
    utils._BYREF_FLOAT64, # Input, grisk.
    utils._EngineFloat64ArrayType.c_type, # Input, r[n].
    utils._EngineFloat64ArrayType.c_type, # Input, q[n].
    utils._EngineFloat64ArrayType.c_type, # Output, p[ldp, n].
    utils._BYREF_INT, # Input, ldp.
    utils._EngineFloat64ArrayType.c_type, # Output, delta[ldp, n].
    utils._EngineFloat64ArrayType.c_type, # Output, gamma[ldp, n].
    utils._EngineFloat64ArrayType.c_type, # Output, vega[ldp, n].
    utils._EngineFloat64ArrayType.c_type, # Output, theta[ldp, n].
    utils._EngineFloat64ArrayType.c_type, # Output, rho[ldp, n].
    utils._EngineFloat64ArrayType.c_type, # Output, vanna[ldp, n].
    utils._EngineFloat64ArrayType.c_type, # Output, charm[ldp, n].
    utils._EngineFloat64ArrayType.c_type, # Output, speed[ldp, n].
    utils._EngineFloat64ArrayType.c_type, # Output, zomma[ldp, n].
    utils._EngineFloat64ArrayType.c_type, # Output, vomma[ldp, n].
    utils._EngineFloat64ArrayType.c_type, # Output, dp_dx[ldp, n].
    utils._EngineFloat64ArrayType.c_type, # Output, dp_dq[ldp, n].
    utils._EngineFloat64ArrayType.c_type, # Output, dp_deta[ldp, n].
    utils._EngineFloat64ArrayType.c_type, # Output, dp_dkappa[ldp, n].
    utils._EngineFloat64ArrayType.c_type, # Output, dp_dsigmav[ldp, n].
    utils._EngineFloat64ArrayType.c_type, # Output, dp_dcorr[ldp, n].
    utils._EngineFloat64ArrayType.c_type, # Output, dp_dgrisk[ldp, n].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of calput.
)
